/**
 * @function doSigndel
 */
"use strict";

const apemanpromise = require('apemanpromise'),
    doSignget = require('./do_signget');

/** @lends doSigndel */
function doSigndel(User, Sign, signed) {
    return doSignget(User, Sign, signed)
        .then(signed => {
            return User.findById(signed.user.id)
                .then(user =>
                    Sign.findAll({
                            where: {user_id: user.id}
                        })
                        .then(signs =>
                            apemanpromise.all(
                                signs.map(sign => sign.destroy())
                            )
                        )
                        .then(() => user.destroy())
                )
                .then(()=> {
                    return signed;
                });
        });
}

module.exports = doSigndel;
