/**
 * @function doSignin
 * @returns Promise
 */

"use strict";

const doSignget = require('./do_signget');

function doSignin(User, Sign, data, digest) {
    return Sign
        .findAll({where: {sign_key: data.sign_key}, limit: 1})
        .then(signs => signs && signs.shift())
        .then(sign => {
            if (!sign) {
                return null;
            }
            return digest(data.password, sign.password_salt)
                .then(hash => sign && (sign.password_hash === hash))
                .then(valid => {
                    if (!valid) {
                        return null;
                    }
                    return sign
                        .update({
                            signin_at: new Date()
                        })
                        .then(sign => doSignget(User, Sign, sign))
                });
        });
}


module.exports = doSignin;

