/**
 * @function doSignout
 * @returns Promise
 */

"use strict";

const doSignget = require('./do_signget');

/** @lends doSignout */
function doSignout(User, Sign, signed) {
    return Sign
        .findById(signed.id)
        .then(sign => {
            if (!sign) {
                return null;
            }
            return User.findById(sign.get('id'))
                .then(user =>
                    sign.update({
                        signout_at: new Date()
                    })
                )
                .then(sign => doSignget(User, Sign, signed))
        })
        .then();
}


module.exports = doSignout;

